/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.circletask.PVPMatchTimeConfig
 *  fire.pb.main.ConfigManager
 *  fire.pb.talk.MessageMgr
 *  mkdb.Mkdb
 *  mkdb.Procedure
 *  mkio.Protocol
 *  xbean.PvP5QueueRole
 *  xtable.Properties
 *  xtable.Roleid2teamid
 */
package fire.pb.battle.pvp5;

import fire.pb.battle.pvp5.PPvP5NewBattle;
import fire.pb.battle.pvp5.PvP5Control;
import fire.pb.battle.pvp5.PvP5RaceProxy;
import fire.pb.battle.pvp5.PvP5RoleProxy;
import fire.pb.battle.pvp5.SPvP5MatchResult;
import fire.pb.circletask.PVPMatchTimeConfig;
import fire.pb.main.ConfigManager;
import fire.pb.talk.MessageMgr;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.concurrent.TimeUnit;
import mkdb.Mkdb;
import mkdb.Procedure;
import mkio.Protocol;
import xbean.PvP5QueueRole;
import xtable.Properties;
import xtable.Roleid2teamid;

public class PPvP5PairBattleFromQueue
extends Procedure {
    private final int grade;
    public Map<Integer, PVPMatchTimeConfig> matchConfs = ConfigManager.getInstance().getConf(PVPMatchTimeConfig.class);

    public PPvP5PairBattleFromQueue(int grade) {
        this.grade = grade;
    }

    protected boolean process() {
        PvP5RaceProxy race = PvP5RaceProxy.getPvP5RaceProxy(this.grade);
        if (race.getXRace() == null) {
            return false;
        }
        if (!race.isOpening()) {
            return false;
        }
        if (race.getXRace().getWaitingqueue().size() < 2) {
            return false;
        }
        long now = System.currentTimeMillis();
        ArrayList<PvP5RoleProxy> pvpRoleProxys = new ArrayList<PvP5RoleProxy>();
        Iterator it = race.getXRace().getWaitingqueue().iterator();
        while (it.hasNext()) {
            PvP5QueueRole queueRole = (PvP5QueueRole)it.next();
            PvP5RoleProxy pvpRoleProxy = PPvP5PairBattleFromQueue.getValidRole(race, queueRole.getRoleid(), now);
            if (pvpRoleProxy == null) {
                it.remove();
                PvP5RoleProxy.setTeamMemberPvPState(queueRole.getRoleid(), 0);
                PvP5RoleProxy.notifyTeamProtocol(queueRole.getRoleid(), (Protocol)MessageMgr.getMsgNotify((int)172026, (int)0, null));
                continue;
            }
            pvpRoleProxys.add(pvpRoleProxy);
        }
        int queueSize = pvpRoleProxys.size();
        int pairNum = this.selectPair(race, pvpRoleProxys, 0, 0, now);
        if (PvP5Control.getLogger().isInfoEnabled()) {
            PvP5Control.getLogger().info((Object)("PVP5::[PPvP5PairBattleFromQueue] pair end. grade:" + this.grade + " queueSize:" + queueSize + " pairNum:" + pairNum + " roleNumCampA:" + race.getXRace().getAllrolesidcampa().size() + " roleNumCampB:" + race.getXRace().getAllrolesidcampb().size() + " rankNumCampA:" + race.getXRace().getAllrolescampa().size() + " rankNumCampB:" + race.getXRace().getAllrolescampb().size()));
        }
        return true;
    }

    private static PvP5RoleProxy getValidRole(PvP5RaceProxy race, long roleId, long now) {
        PvP5RoleProxy pvpRoleProxy = null;
        List<Long> roleIds = PvP5RoleProxy.getTeamMemberIds(roleId);
        if (roleIds.get(0) == roleId) {
            for (long id : roleIds) {
                PvP5RoleProxy tempPvpRoleProxy = PvP5RoleProxy.getPvP5RoleProxy(id, true);
                if (!race.roleIsCanReady(tempPvpRoleProxy.getRoleId(), false)) {
                    return null;
                }
                if (tempPvpRoleProxy.getRoleId() != roleId) continue;
                pvpRoleProxy = tempPvpRoleProxy;
            }
        }
        return pvpRoleProxy;
    }

    private int selectPair(PvP5RaceProxy race, List<PvP5RoleProxy> pvpRoleProxys, int startIndex, int pairNum, long now) {
        long hostWaitingTime;
        int size = race.getXRace().getWaitingqueue().size();
        if (startIndex >= size - 1) {
            return pairNum;
        }
        PvP5QueueRole hostRole = (PvP5QueueRole)race.getXRace().getWaitingqueue().get(startIndex);
        PvP5RoleProxy pvpHostRole = pvpRoleProxys.get(startIndex);
        if (!PPvP5PairBattleFromQueue.roleCanFight(pvpHostRole, now, hostWaitingTime = Math.max(0L, now - hostRole.getEnterqueuetime() - 31000L))) {
            return this.selectPair(race, pvpRoleProxys, startIndex + 1, pairNum, now);
        }
        for (int i = startIndex + 1; i < size; ++i) {
            long guestWaitingTime;
            PvP5RoleProxy pvpGuestRole = pvpRoleProxys.get(i);
            if (!PPvP5PairBattleFromQueue.roleCanFight(pvpGuestRole, now, guestWaitingTime = Math.max(0L, now - hostRole.getEnterqueuetime() - 31000L)) || !this.pair(pvpHostRole, pvpGuestRole, hostWaitingTime)) continue;
            race.getXRace().getWaitingqueue().remove(startIndex);
            pvpRoleProxys.remove(startIndex);
            race.getXRace().getWaitingqueue().remove(i - 1);
            pvpRoleProxys.remove(i - 1);
            PPvP5PairBattleFromQueue.sendMatchResult(pvpHostRole.getRoleId(), pvpGuestRole.getRoleId());
            PPvP5PairBattleFromQueue.sendMatchResult(pvpGuestRole.getRoleId(), pvpHostRole.getRoleId());
            PPvP5PairBattleFromQueue.NewBattle(this.grade, pvpHostRole.getRoleId(), pvpGuestRole.getRoleId(), now);
            return this.selectPair(race, pvpRoleProxys, startIndex, pairNum + 1, now);
        }
        return this.selectPair(race, pvpRoleProxys, startIndex + 1, pairNum, now);
    }

    private boolean pair(PvP5RoleProxy pvpHostRole, PvP5RoleProxy pvpGuestRole, long waitingTime) {
        if (pvpHostRole.getRoleId() == pvpGuestRole.getRoleId()) {
            return false;
        }
        if (pvpHostRole.getCamp() == pvpGuestRole.getCamp()) {
            return false;
        }
        if (pvpHostRole.getExcellent() != pvpGuestRole.getExcellent()) {
            return false;
        }
        int hostLevel = pvpHostRole.getScoreLevel();
        int guestLevel = pvpGuestRole.getScoreLevel();
        int seconds = (int)(waitingTime / 1000L) + 1;
        int levelmod = 999;
        PVPMatchTimeConfig conf = this.matchConfs.get(seconds);
        if (conf != null) {
            levelmod = conf.lev;
        }
        int hostRoleLv = Properties.selectLevel((Long)pvpHostRole.getRoleId());
        int guestRoleLv = Properties.selectLevel((Long)pvpGuestRole.getRoleId());
        return Math.abs(hostLevel - guestLevel) + Math.abs(hostRoleLv - guestRoleLv) / 5 <= levelmod;
    }

    public static boolean roleCanFight(PvP5RoleProxy pvpRoleProxy, long now, long waitingTime) {
        long t = now - pvpRoleProxy.getLastBattleTime();
        long t2 = now - pvpRoleProxy.getLastEnterTime();
        return t > 31000L && t2 > 31000L;
    }

    public static void sendMatchResult(long roleId, long targetId) {
        SPvP5MatchResult send = new SPvP5MatchResult();
        PvP5RoleProxy.notifyTeamProtocol(roleId, send);
    }

    private static void NewBattle(final int grade, final long hostRoleId, final long guestRoleId, final long now) {
        final List<Long> hostTeamMemberIds = PvP5RoleProxy.getTeamMemberIds(hostRoleId);
        final List<Long> guestTeamMemberIds = PvP5RoleProxy.getTeamMemberIds(guestRoleId);
        PvP5RoleProxy.setTeamMemberPvPState(hostRoleId, 2);
        PvP5RoleProxy.setTeamMemberPvPState(guestRoleId, 2);
        Procedure.pexecuteWhileCommit((Procedure)new Procedure(){

            public boolean process() {
                Mkdb.executor().schedule(new Runnable(){

                    @Override
                    public void run() {
                        new Procedure(){

                            public boolean process() {
                                List<Long> roleIds;
                                boolean valid = true;
                                PvP5RaceProxy race = PvP5RaceProxy.getPvP5RaceProxy(grade);
                                if (race.getXRace() == null) {
                                    valid = false;
                                }
                                HashSet<Long> roleIdSet = new HashSet<Long>();
                                if (valid) {
                                    roleIds = PvP5RoleProxy.getTeamMemberIds(hostRoleId);
                                    if (roleIds.size() > 5 || roleIds.size() != hostTeamMemberIds.size() || !roleIds.containsAll(hostTeamMemberIds)) {
                                        valid = false;
                                    }
                                    roleIdSet.addAll(roleIds);
                                }
                                if (valid) {
                                    roleIds = PvP5RoleProxy.getTeamMemberIds(guestRoleId);
                                    if (roleIds.size() > 5 || roleIds.size() != guestTeamMemberIds.size() || !roleIds.containsAll(guestTeamMemberIds)) {
                                        valid = false;
                                    }
                                    for (long id : roleIds) {
                                        if (!roleIdSet.contains(id)) continue;
                                        valid = false;
                                        break;
                                    }
                                }
                                if (valid && PPvP5PairBattleFromQueue.getValidRole(race, hostRoleId, now) == null) {
                                    valid = false;
                                }
                                if (valid && PPvP5PairBattleFromQueue.getValidRole(race, hostRoleId, now) == null) {
                                    valid = false;
                                }
                                if (valid) {
                                    Long tempGuestTeamId;
                                    long hostTeamId = -1L;
                                    long guestTeamId = -1L;
                                    Long tempHostTeamId = Roleid2teamid.select((Long)hostRoleId);
                                    if (tempHostTeamId != null) {
                                        hostTeamId = tempHostTeamId;
                                    }
                                    if ((tempGuestTeamId = Roleid2teamid.select((Long)guestRoleId)) != null) {
                                        guestTeamId = tempGuestTeamId;
                                    }
                                    Procedure.pexecuteWhileCommit((Procedure)new PPvP5NewBattle(grade, hostRoleId, guestRoleId, hostTeamId, guestTeamId));
                                } else {
                                    PvP5RoleProxy.setTeamMemberPvPState(hostRoleId, 0);
                                    PvP5RoleProxy.setTeamMemberPvPState(guestRoleId, 0);
                                }
                                return true;
                            }
                        }.submit();
                    }
                }, 1L, TimeUnit.SECONDS);
                return true;
            }
        });
    }
}

